
// PURPOSE
// this program illustrates simple array manipulation by implementing 
// the bubble sort we have looked at in JavaScript

// STRUCTURE
// we have one class and in that class are 4 methods...
// main, bubbleup, bubblesort, and printArray
// all are static methods as they are in the main class
// no objects in this program

public class SampleArrPractice {

  public static void main (String[] args) {
  
     int[] nums = { 
       80, 12, 3,-5, 101, 16, -77, 80, 0, 43, 99, -19 , 48, 15, 77, 78, 79, -5 , 80, 81
     };
     // defining the array with an array literal
     // a more traditional sort might read the input from a file, 
     // or from the keyboard or some other external input device
     // perhaps accessing a DB over a network, almost anything
     
     System.out.print("Initial data: ");
     printArray(nums);
     
     bubblesort(nums);
     
     System.out.print("Sorted data:  ");
     printArray(nums);
  }
  
  public static void bubblesort (int[] arr) {
    for (int i=0; i<arr.length-1; i++) {
       bubbleup(arr);
    }
  }
  
  private static void bubbleup (int[] a) {
    int tmp;
    for (int i=0; i<a.length-1; i++) {
       if (a[i]>a[i+1]) { tmp=a[i]; a[i]=a[i+1]; a[i+1]=tmp; }
    }
  }
  
  private static void printArray (int[] a) {
    for (int i=0; i<a.length; i++) {
      System.out.print("  " + a[i]);
    }
    System.out.println();
  }

}

// for fun and practice... make 2 new versions of this

/* 1)
   read the input values from the keyboard
   using the scanner object, like you are
   using in A1

   you can do this a few ways...
   
   1.a) you can just allocate a big array... say 100 elements
   then read an integer from input (the number of
   elements that will be typed after that)
   then type in those elements and sort.  You will be limited
   to 100 (in this case) elements since the array will
   be big enough to hold only 100 elements
 
   2.a) you can take the integer you read from the keyboard
   and allocate an array exactly big enough to hold the 
   elements that will be typed
   */

/* 2)  
   forget all that typing and generate random integers in some
   range like 0 to 900,000,000 (int can hold up to 2,147,483,647)
   
   just pick a huge array size... maybe 500,000 elements, and allocate
   the array. Then populate the array by putting a random number in
   each array location. Use Math.random to generate the random nums
   
   Then you can try bubble sorting large sequences of data.  If you
   have the patience.
   */
