
public class EnCapso {
   // data fields
   private String fName;
   private String lName;
   private int age;
   private double salary;
   private int awards;
   
   // constructor, same name as class  
   EnCapso (String fn, String ln, int a, double s) { 
     this.fName = fn;
     this.lName = ln;
     this.age = a;
     this.salary = s;
     this.awards = 0;
   }
   
   // public methods are the interface...
   // methods that are visible elsewhere and can be called
   // to make the object do work
   
   // getters and setters
   public int getAge() { return this.age; }
   public void setAge(int a) { this.age = a; }
   
   public double getSalary() { return this.salary; }
   public void setSalary(double num) { this.salary = num; }

   // design decision to have no getter or setter for fName, lName
   // other public methods
   public String getName() { return this.fName + " " + this.lName; } 
   public void raiseSalary(double inc) { this.salary += inc; }
 
   // private methods... used only in other methods of this object
   // like helper functions, if needed
   // private methods can be uses in methods here in this class
   // private methods cannot be called by code outside this class
   
   private void addAward() { this.awards++; }
   
   private boolean isCommendable (int thresh ) {
     return ( this.awards > thresh ) ;
   }
}
