
public class NoCapso {
   // data fields
   public String fName;   // public since not declared private
   public String lName;   // public
   public int age;        // public
   public double salary;  // public
   public int awards;   // public
   
   // constructor, same name as class  
   NoCapso (String fn, String ln, int a, double s) { 
     this.fName = fn;
     this.lName = ln;
     this.age = a;
     this.salary = s;
     this.awards = 0;
   }
   
   // public methods are the interface...
   // methods that are visible elsewhere and can be called
   // to make the object do work
   
   // getters and setters
   public int getAge() { return this.age; }
   public void setAge(int a) { this.age = a; }
   
   public double getSalary() { return this.salary; }
   public void setSalary(double num) { this.salary = num; }

   // design decision to have no getter or setter for fName, lName
   // other public methods
   public String getName() { return this.fName + " " + this.lName; } 
   public void raiseSalary(double inc) { this.salary += inc; }
 
   // helper methods... used only in other methods of this object
   // if declared public, though, they can be
   // called by code outside this class
   // we probably dont want this to happen, since they are helpers
   // for the methods in here
   // we really want them to be private
   
   public void addAward() { this.awards++; }
   
   boolean isCommendable (int thresh ) {
     return ( this.awards > thresh ) ;
   }
}
